/* Copyright Erno de Weerd
 * 2002
 * AirKnow@hotmail.com
 */

using System;
using System.Drawing;
using AirKnow.AL.Creatures;

namespace AirKnow.AL.Creatures.Ants
{
	public class LangtonsAnt : Creature
	{
		private int directionX;
		private int directionY;
		private Color trailColor1;
		private Color trailColor2;
		
		public LangtonsAnt(int x, int y, Color color, int directionX ,int directionY, Color trailColor1, Color trailColor2):base(x, y, color)
		{
			this.directionX = directionX;
			this.directionY = directionY;
			this.TrailColor1 = trailColor1;
			this.TrailColor2 = trailColor2;
		}

		
		public Color TrailColor1
		{
			get { return trailColor1; }
			set	{ trailColor1 = value; }
		}
		
		public Color TrailColor2
		{
			get { return trailColor2; }
			set	{ trailColor2 = value; }
		}

		private void turnRight()
		{
			int dy = directionY;
			directionY = directionX;
			directionX = -dy;
		}

		private void turnLeft()
		{
			int dy = directionY;
			directionY = -directionX;
			directionX = dy;
		}

		public Color ProcessRules(Color currentSquareColor)
		{
			if( currentSquareColor.ToArgb() != TrailColor1.ToArgb())
			{
				turnRight();
				return TrailColor1;
			}
			else 
			{
				turnLeft();
				return TrailColor2;
			}
		}

		public void Forward()
		{
			X += directionX;
			Y += directionY;
		}
	}
}
