/* Copyright Erno de Weerd
 * 2002
 * AirKnow@hotmail.com
 */
  
using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Threading;
using AirKnow.AL.Creatures.Ants;

namespace LangtonsAntTest
{
	
	public class FormLangtonsAnt : System.Windows.Forms.Form
	{
		private Color AntColor = Color.Blue;
		private Color SelectedAntColor = Color.Red;
		private Thread processAntsThread;
		private ThreadPriority antPriority = ThreadPriority.Normal;
		private ArrayList ants;
		private int selectedAntIndex;
		private bool running = false;
		private int steps = 0;
		
		private System.Windows.Forms.GroupBox groupBoxSelectedAnt;
		private System.Windows.Forms.Button buttonPauseAnt;
		private System.Windows.Forms.Button buttonRemoveAnt;
		private System.Windows.Forms.Button buttonPreviousAnt;
		private System.Windows.Forms.Button buttonNextAnt;
		private System.Windows.Forms.GroupBox groupBoxNewAnt;
		private System.Windows.Forms.Button buttonNewAnt;
		private System.Windows.Forms.GroupBox groupBoxPopulation;
		private System.Windows.Forms.Button buttonClear;
		private System.Windows.Forms.Button buttonOneStep;
		private System.Windows.Forms.Button buttonMoveAntUp;
		private System.Windows.Forms.Button buttonMoveAntDown;
		private System.Windows.Forms.Button buttonMoveAntLeft;
		private System.Windows.Forms.Button buttonMoveAntRight;
		private System.Windows.Forms.ToolTip toolTip;
		private System.Windows.Forms.GroupBox groupBoxDirection;
		private System.Windows.Forms.RadioButton radioButtonNewAntRight;
		private System.Windows.Forms.RadioButton radioButtonNewAntLeft;
		private System.Windows.Forms.RadioButton radioButtonNewAntUp;
		private System.Windows.Forms.RadioButton radioButtonNewAntDown;
		private System.Windows.Forms.GroupBox groupBoxNewAntColor;
		private System.Windows.Forms.Button buttonPopulationKill;
		private System.Windows.Forms.Label labelRuns;
		private System.Windows.Forms.MainMenu mainMenu;
		private System.Windows.Forms.MenuItem menuItemSetBackgroundColor;
		private System.Windows.Forms.MenuItem menuItemExit;
		private System.Windows.Forms.MenuItem menuItemFile;
		private System.Windows.Forms.MenuItem menuItemHelp;
		private System.Windows.Forms.MenuItem menuItemAbout;
		private System.Windows.Forms.MenuItem menuItemOptions;
		private System.Windows.Forms.ColorDialog colorDialog;
		private System.Windows.Forms.Label labelNewAntColor1;
		private System.Windows.Forms.Label labelNewAntColor2;
		private System.Windows.Forms.Button buttonPopulationWalk;
		private AirKnow.AL.Controls.CreaturePlayField creaturePlayFieldAnts;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItemAntPriority;
		private System.Windows.Forms.MenuItem menuItemAntPrioritySlowest;
		private System.Windows.Forms.MenuItem menuItemAntPrioritySlow;
		private System.Windows.Forms.MenuItem menuItemAntPriorityNormal;
		private System.Windows.Forms.MenuItem menuItemAntPriorityFast;
		private System.Windows.Forms.MenuItem menuItemAntPriorityFastest;
		private System.Windows.Forms.GroupBox groupBoxDisplay;
		private System.Windows.Forms.RadioButton radioButtonBlocks;
		private System.Windows.Forms.RadioButton radioButtonBilinear;
		private System.Windows.Forms.RadioButton radioButtonBicubic;
		private System.ComponentModel.IContainer components;

		public FormLangtonsAnt()
		{
			//
			// Required for Windows Form Designer support
			//
			

			InitializeComponent();

			labelNewAntColor2.BackColor = creaturePlayFieldAnts.FieldColor;

			ants = new ArrayList();
			// get the synchronized version to be able to add ants while running
			ants = ArrayList.Synchronized(ants);
			creaturePlayFieldAnts.Creatures = ants;

			radioButtonBlocks.Checked = (creaturePlayFieldAnts.Style == InterpolationMode.Low);
			radioButtonBilinear.Checked = (creaturePlayFieldAnts.Style == InterpolationMode.HighQualityBilinear);
			radioButtonBicubic.Checked = (creaturePlayFieldAnts.Style == InterpolationMode.HighQualityBicubic);
			
			attachToolTips();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				stopProcessThread();

				if (components != null) 
				{
					components.Dispose();
					
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.labelRuns = new System.Windows.Forms.Label();
			this.groupBoxSelectedAnt = new System.Windows.Forms.GroupBox();
			this.buttonMoveAntRight = new System.Windows.Forms.Button();
			this.buttonMoveAntLeft = new System.Windows.Forms.Button();
			this.buttonMoveAntDown = new System.Windows.Forms.Button();
			this.buttonMoveAntUp = new System.Windows.Forms.Button();
			this.buttonPauseAnt = new System.Windows.Forms.Button();
			this.buttonRemoveAnt = new System.Windows.Forms.Button();
			this.buttonPreviousAnt = new System.Windows.Forms.Button();
			this.buttonNextAnt = new System.Windows.Forms.Button();
			this.groupBoxNewAnt = new System.Windows.Forms.GroupBox();
			this.groupBoxNewAntColor = new System.Windows.Forms.GroupBox();
			this.labelNewAntColor2 = new System.Windows.Forms.Label();
			this.labelNewAntColor1 = new System.Windows.Forms.Label();
			this.groupBoxDirection = new System.Windows.Forms.GroupBox();
			this.radioButtonNewAntRight = new System.Windows.Forms.RadioButton();
			this.radioButtonNewAntLeft = new System.Windows.Forms.RadioButton();
			this.radioButtonNewAntUp = new System.Windows.Forms.RadioButton();
			this.radioButtonNewAntDown = new System.Windows.Forms.RadioButton();
			this.buttonNewAnt = new System.Windows.Forms.Button();
			this.toolTip = new System.Windows.Forms.ToolTip(this.components);
			this.menuItemFile = new System.Windows.Forms.MenuItem();
			this.menuItemExit = new System.Windows.Forms.MenuItem();
			this.buttonClear = new System.Windows.Forms.Button();
			this.groupBoxPopulation = new System.Windows.Forms.GroupBox();
			this.buttonPopulationKill = new System.Windows.Forms.Button();
			this.buttonPopulationWalk = new System.Windows.Forms.Button();
			this.buttonOneStep = new System.Windows.Forms.Button();
			this.menuItemHelp = new System.Windows.Forms.MenuItem();
			this.menuItemAbout = new System.Windows.Forms.MenuItem();
			this.menuItemOptions = new System.Windows.Forms.MenuItem();
			this.menuItemSetBackgroundColor = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItemAntPriority = new System.Windows.Forms.MenuItem();
			this.menuItemAntPrioritySlowest = new System.Windows.Forms.MenuItem();
			this.menuItemAntPrioritySlow = new System.Windows.Forms.MenuItem();
			this.menuItemAntPriorityNormal = new System.Windows.Forms.MenuItem();
			this.menuItemAntPriorityFast = new System.Windows.Forms.MenuItem();
			this.menuItemAntPriorityFastest = new System.Windows.Forms.MenuItem();
			this.mainMenu = new System.Windows.Forms.MainMenu();
			this.colorDialog = new System.Windows.Forms.ColorDialog();
			this.creaturePlayFieldAnts = new AirKnow.AL.Controls.CreaturePlayField();
			this.groupBoxDisplay = new System.Windows.Forms.GroupBox();
			this.radioButtonBicubic = new System.Windows.Forms.RadioButton();
			this.radioButtonBilinear = new System.Windows.Forms.RadioButton();
			this.radioButtonBlocks = new System.Windows.Forms.RadioButton();
			this.groupBoxSelectedAnt.SuspendLayout();
			this.groupBoxNewAnt.SuspendLayout();
			this.groupBoxNewAntColor.SuspendLayout();
			this.groupBoxDirection.SuspendLayout();
			this.groupBoxPopulation.SuspendLayout();
			this.groupBoxDisplay.SuspendLayout();
			this.SuspendLayout();
			// 
			// labelRuns
			// 
			this.labelRuns.Location = new System.Drawing.Point(8, 24);
			this.labelRuns.Name = "labelRuns";
			this.labelRuns.Size = new System.Drawing.Size(88, 16);
			this.labelRuns.TabIndex = 6;
			this.labelRuns.Text = "Steps: 0";
			// 
			// groupBoxSelectedAnt
			// 
			this.groupBoxSelectedAnt.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.groupBoxSelectedAnt.Controls.AddRange(new System.Windows.Forms.Control[] {
																							  this.buttonMoveAntRight,
																							  this.buttonMoveAntLeft,
																							  this.buttonMoveAntDown,
																							  this.buttonMoveAntUp,
																							  this.buttonPauseAnt,
																							  this.buttonRemoveAnt,
																							  this.buttonPreviousAnt,
																							  this.buttonNextAnt});
			this.groupBoxSelectedAnt.Enabled = false;
			this.groupBoxSelectedAnt.Location = new System.Drawing.Point(520, 8);
			this.groupBoxSelectedAnt.Name = "groupBoxSelectedAnt";
			this.groupBoxSelectedAnt.Size = new System.Drawing.Size(104, 216);
			this.groupBoxSelectedAnt.TabIndex = 11;
			this.groupBoxSelectedAnt.TabStop = false;
			this.groupBoxSelectedAnt.Text = "Selected Ant";
			// 
			// buttonMoveAntRight
			// 
			this.buttonMoveAntRight.Location = new System.Drawing.Point(64, 128);
			this.buttonMoveAntRight.Name = "buttonMoveAntRight";
			this.buttonMoveAntRight.Size = new System.Drawing.Size(24, 24);
			this.buttonMoveAntRight.TabIndex = 14;
			this.buttonMoveAntRight.Text = ">";
			this.buttonMoveAntRight.Click += new System.EventHandler(this.buttonMoveAntRight_Click);
			// 
			// buttonMoveAntLeft
			// 
			this.buttonMoveAntLeft.Location = new System.Drawing.Point(16, 128);
			this.buttonMoveAntLeft.Name = "buttonMoveAntLeft";
			this.buttonMoveAntLeft.Size = new System.Drawing.Size(24, 24);
			this.buttonMoveAntLeft.TabIndex = 13;
			this.buttonMoveAntLeft.Text = "<";
			this.buttonMoveAntLeft.Click += new System.EventHandler(this.buttonMoveAntLeft_Click);
			// 
			// buttonMoveAntDown
			// 
			this.buttonMoveAntDown.Location = new System.Drawing.Point(40, 152);
			this.buttonMoveAntDown.Name = "buttonMoveAntDown";
			this.buttonMoveAntDown.Size = new System.Drawing.Size(24, 24);
			this.buttonMoveAntDown.TabIndex = 12;
			this.buttonMoveAntDown.Text = "v";
			this.buttonMoveAntDown.Click += new System.EventHandler(this.buttonMoveAntDown_Click);
			// 
			// buttonMoveAntUp
			// 
			this.buttonMoveAntUp.Location = new System.Drawing.Point(40, 104);
			this.buttonMoveAntUp.Name = "buttonMoveAntUp";
			this.buttonMoveAntUp.Size = new System.Drawing.Size(24, 24);
			this.buttonMoveAntUp.TabIndex = 11;
			this.buttonMoveAntUp.Text = "^";
			this.buttonMoveAntUp.Click += new System.EventHandler(this.buttonMoveAntUp_Click);
			// 
			// buttonPauseAnt
			// 
			this.buttonPauseAnt.Location = new System.Drawing.Point(8, 24);
			this.buttonPauseAnt.Name = "buttonPauseAnt";
			this.buttonPauseAnt.Size = new System.Drawing.Size(88, 32);
			this.buttonPauseAnt.TabIndex = 10;
			this.buttonPauseAnt.Text = "Pause";
			this.buttonPauseAnt.Click += new System.EventHandler(this.buttonPauseAnt_Click);
			// 
			// buttonRemoveAnt
			// 
			this.buttonRemoveAnt.Location = new System.Drawing.Point(8, 64);
			this.buttonRemoveAnt.Name = "buttonRemoveAnt";
			this.buttonRemoveAnt.Size = new System.Drawing.Size(88, 32);
			this.buttonRemoveAnt.TabIndex = 9;
			this.buttonRemoveAnt.Text = "Remove";
			this.buttonRemoveAnt.Click += new System.EventHandler(this.buttonRemoveAnt_Click);
			// 
			// buttonPreviousAnt
			// 
			this.buttonPreviousAnt.Location = new System.Drawing.Point(8, 184);
			this.buttonPreviousAnt.Name = "buttonPreviousAnt";
			this.buttonPreviousAnt.Size = new System.Drawing.Size(40, 24);
			this.buttonPreviousAnt.TabIndex = 8;
			this.buttonPreviousAnt.Text = "<";
			this.buttonPreviousAnt.Click += new System.EventHandler(this.buttonPreviousAnt_Click);
			// 
			// buttonNextAnt
			// 
			this.buttonNextAnt.Location = new System.Drawing.Point(56, 184);
			this.buttonNextAnt.Name = "buttonNextAnt";
			this.buttonNextAnt.Size = new System.Drawing.Size(40, 24);
			this.buttonNextAnt.TabIndex = 5;
			this.buttonNextAnt.Text = ">";
			this.buttonNextAnt.Click += new System.EventHandler(this.buttonNextAnt_Click);
			// 
			// groupBoxNewAnt
			// 
			this.groupBoxNewAnt.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.groupBoxNewAnt.Controls.AddRange(new System.Windows.Forms.Control[] {
																						 this.groupBoxNewAntColor,
																						 this.groupBoxDirection,
																						 this.buttonNewAnt});
			this.groupBoxNewAnt.Location = new System.Drawing.Point(408, 232);
			this.groupBoxNewAnt.Name = "groupBoxNewAnt";
			this.groupBoxNewAnt.Size = new System.Drawing.Size(216, 120);
			this.groupBoxNewAnt.TabIndex = 12;
			this.groupBoxNewAnt.TabStop = false;
			this.groupBoxNewAnt.Text = "New Ant";
			// 
			// groupBoxNewAntColor
			// 
			this.groupBoxNewAntColor.Controls.AddRange(new System.Windows.Forms.Control[] {
																							  this.labelNewAntColor2,
																							  this.labelNewAntColor1});
			this.groupBoxNewAntColor.Location = new System.Drawing.Point(120, 16);
			this.groupBoxNewAntColor.Name = "groupBoxNewAntColor";
			this.groupBoxNewAntColor.Size = new System.Drawing.Size(88, 56);
			this.groupBoxNewAntColor.TabIndex = 8;
			this.groupBoxNewAntColor.TabStop = false;
			this.groupBoxNewAntColor.Text = "Trail colors";
			// 
			// labelNewAntColor2
			// 
			this.labelNewAntColor2.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.labelNewAntColor2.Location = new System.Drawing.Point(48, 16);
			this.labelNewAntColor2.Name = "labelNewAntColor2";
			this.labelNewAntColor2.Size = new System.Drawing.Size(37, 37);
			this.labelNewAntColor2.TabIndex = 5;
			this.labelNewAntColor2.Click += new System.EventHandler(this.labelNewAntColor2_Click);
			// 
			// labelNewAntColor1
			// 
			this.labelNewAntColor1.BackColor = System.Drawing.Color.Black;
			this.labelNewAntColor1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.labelNewAntColor1.Location = new System.Drawing.Point(3, 16);
			this.labelNewAntColor1.Name = "labelNewAntColor1";
			this.labelNewAntColor1.Size = new System.Drawing.Size(37, 37);
			this.labelNewAntColor1.TabIndex = 5;
			this.labelNewAntColor1.Click += new System.EventHandler(this.labelNewAntColor1_Click);
			// 
			// groupBoxDirection
			// 
			this.groupBoxDirection.Controls.AddRange(new System.Windows.Forms.Control[] {
																							this.radioButtonNewAntRight,
																							this.radioButtonNewAntLeft,
																							this.radioButtonNewAntUp,
																							this.radioButtonNewAntDown});
			this.groupBoxDirection.Location = new System.Drawing.Point(8, 16);
			this.groupBoxDirection.Name = "groupBoxDirection";
			this.groupBoxDirection.Size = new System.Drawing.Size(88, 96);
			this.groupBoxDirection.TabIndex = 7;
			this.groupBoxDirection.TabStop = false;
			this.groupBoxDirection.Text = "Direction";
			// 
			// radioButtonNewAntRight
			// 
			this.radioButtonNewAntRight.Location = new System.Drawing.Point(8, 56);
			this.radioButtonNewAntRight.Name = "radioButtonNewAntRight";
			this.radioButtonNewAntRight.Size = new System.Drawing.Size(64, 16);
			this.radioButtonNewAntRight.TabIndex = 6;
			this.radioButtonNewAntRight.Text = "Right";
			// 
			// radioButtonNewAntLeft
			// 
			this.radioButtonNewAntLeft.Location = new System.Drawing.Point(8, 40);
			this.radioButtonNewAntLeft.Name = "radioButtonNewAntLeft";
			this.radioButtonNewAntLeft.Size = new System.Drawing.Size(64, 16);
			this.radioButtonNewAntLeft.TabIndex = 6;
			this.radioButtonNewAntLeft.Text = "Left";
			// 
			// radioButtonNewAntUp
			// 
			this.radioButtonNewAntUp.Checked = true;
			this.radioButtonNewAntUp.Location = new System.Drawing.Point(8, 24);
			this.radioButtonNewAntUp.Name = "radioButtonNewAntUp";
			this.radioButtonNewAntUp.Size = new System.Drawing.Size(64, 16);
			this.radioButtonNewAntUp.TabIndex = 6;
			this.radioButtonNewAntUp.TabStop = true;
			this.radioButtonNewAntUp.Text = "Up";
			// 
			// radioButtonNewAntDown
			// 
			this.radioButtonNewAntDown.Location = new System.Drawing.Point(8, 72);
			this.radioButtonNewAntDown.Name = "radioButtonNewAntDown";
			this.radioButtonNewAntDown.Size = new System.Drawing.Size(64, 16);
			this.radioButtonNewAntDown.TabIndex = 6;
			this.radioButtonNewAntDown.Text = "Down";
			// 
			// buttonNewAnt
			// 
			this.buttonNewAnt.Location = new System.Drawing.Point(120, 80);
			this.buttonNewAnt.Name = "buttonNewAnt";
			this.buttonNewAnt.Size = new System.Drawing.Size(88, 32);
			this.buttonNewAnt.TabIndex = 4;
			this.buttonNewAnt.Text = "Create";
			this.buttonNewAnt.Click += new System.EventHandler(this.buttonNewAnt_Click);
			// 
			// menuItemFile
			// 
			this.menuItemFile.Index = 0;
			this.menuItemFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItemExit});
			this.menuItemFile.Text = "&File";
			// 
			// menuItemExit
			// 
			this.menuItemExit.Index = 0;
			this.menuItemExit.Text = "E&xit";
			this.menuItemExit.Click += new System.EventHandler(this.menuItemExit_Click);
			// 
			// buttonClear
			// 
			this.buttonClear.Location = new System.Drawing.Point(120, 16);
			this.buttonClear.Name = "buttonClear";
			this.buttonClear.Size = new System.Drawing.Size(88, 32);
			this.buttonClear.TabIndex = 1;
			this.buttonClear.Text = "&Clear";
			this.buttonClear.Click += new System.EventHandler(this.buttonClear_Click);
			// 
			// groupBoxPopulation
			// 
			this.groupBoxPopulation.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.groupBoxPopulation.Controls.AddRange(new System.Windows.Forms.Control[] {
																							 this.buttonPopulationKill,
																							 this.buttonPopulationWalk,
																							 this.buttonOneStep,
																							 this.labelRuns});
			this.groupBoxPopulation.Location = new System.Drawing.Point(408, 8);
			this.groupBoxPopulation.Name = "groupBoxPopulation";
			this.groupBoxPopulation.Size = new System.Drawing.Size(104, 208);
			this.groupBoxPopulation.TabIndex = 13;
			this.groupBoxPopulation.TabStop = false;
			this.groupBoxPopulation.Text = "Population";
			// 
			// buttonPopulationKill
			// 
			this.buttonPopulationKill.Location = new System.Drawing.Point(8, 168);
			this.buttonPopulationKill.Name = "buttonPopulationKill";
			this.buttonPopulationKill.Size = new System.Drawing.Size(88, 32);
			this.buttonPopulationKill.TabIndex = 8;
			this.buttonPopulationKill.Text = "Kill";
			this.buttonPopulationKill.Click += new System.EventHandler(this.buttonPopulationKill_Click);
			// 
			// buttonPopulationWalk
			// 
			this.buttonPopulationWalk.Location = new System.Drawing.Point(8, 88);
			this.buttonPopulationWalk.Name = "buttonPopulationWalk";
			this.buttonPopulationWalk.Size = new System.Drawing.Size(88, 32);
			this.buttonPopulationWalk.TabIndex = 2;
			this.buttonPopulationWalk.Text = "Walk";
			this.buttonPopulationWalk.Click += new System.EventHandler(this.buttonPopulationWalk_Click);
			// 
			// buttonOneStep
			// 
			this.buttonOneStep.Location = new System.Drawing.Point(8, 128);
			this.buttonOneStep.Name = "buttonOneStep";
			this.buttonOneStep.Size = new System.Drawing.Size(88, 32);
			this.buttonOneStep.TabIndex = 7;
			this.buttonOneStep.Text = "One Step";
			this.buttonOneStep.Click += new System.EventHandler(this.buttonOneStep_Click);
			// 
			// menuItemHelp
			// 
			this.menuItemHelp.Index = 2;
			this.menuItemHelp.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.menuItemAbout});
			this.menuItemHelp.Text = "&Help";
			// 
			// menuItemAbout
			// 
			this.menuItemAbout.Index = 0;
			this.menuItemAbout.Text = "A&bout";
			this.menuItemAbout.Click += new System.EventHandler(this.menuItemAbout_Click);
			// 
			// menuItemOptions
			// 
			this.menuItemOptions.Index = 1;
			this.menuItemOptions.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																							this.menuItemSetBackgroundColor,
																							this.menuItem1,
																							this.menuItemAntPriority});
			this.menuItemOptions.Text = "&Options";
			// 
			// menuItemSetBackgroundColor
			// 
			this.menuItemSetBackgroundColor.Index = 0;
			this.menuItemSetBackgroundColor.Text = "Set &Background Color";
			this.menuItemSetBackgroundColor.Click += new System.EventHandler(this.menuItemSetBackgroundColor_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 1;
			this.menuItem1.Text = "-";
			// 
			// menuItemAntPriority
			// 
			this.menuItemAntPriority.Index = 2;
			this.menuItemAntPriority.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																								this.menuItemAntPrioritySlowest,
																								this.menuItemAntPrioritySlow,
																								this.menuItemAntPriorityNormal,
																								this.menuItemAntPriorityFast,
																								this.menuItemAntPriorityFastest});
			this.menuItemAntPriority.Text = "Ant Priority";
			this.menuItemAntPriority.Select += new System.EventHandler(this.menuItemAntPriority_Select);
			// 
			// menuItemAntPrioritySlowest
			// 
			this.menuItemAntPrioritySlowest.Index = 0;
			this.menuItemAntPrioritySlowest.Text = "Slowest";
			this.menuItemAntPrioritySlowest.Click += new System.EventHandler(this.menuItemAntPrioritySlowest_Click);
			// 
			// menuItemAntPrioritySlow
			// 
			this.menuItemAntPrioritySlow.Index = 1;
			this.menuItemAntPrioritySlow.Text = "Slow";
			this.menuItemAntPrioritySlow.Click += new System.EventHandler(this.menuItemAntPrioritySlow_Click);
			// 
			// menuItemAntPriorityNormal
			// 
			this.menuItemAntPriorityNormal.Index = 2;
			this.menuItemAntPriorityNormal.Text = "Normal";
			this.menuItemAntPriorityNormal.Click += new System.EventHandler(this.menuItemAntPriorityNormal_Click);
			// 
			// menuItemAntPriorityFast
			// 
			this.menuItemAntPriorityFast.Index = 3;
			this.menuItemAntPriorityFast.Text = "Fast";
			this.menuItemAntPriorityFast.Click += new System.EventHandler(this.menuItemAntPriorityFast_Click);
			// 
			// menuItemAntPriorityFastest
			// 
			this.menuItemAntPriorityFastest.Index = 4;
			this.menuItemAntPriorityFastest.Text = "Fastest";
			this.menuItemAntPriorityFastest.Click += new System.EventHandler(this.menuItemAntPriorityFastest_Click);
			// 
			// mainMenu
			// 
			this.mainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuItemFile,
																					 this.menuItemOptions,
																					 this.menuItemHelp});
			// 
			// colorDialog
			// 
			this.colorDialog.Color = System.Drawing.SystemColors.Control;
			// 
			// creaturePlayFieldAnts
			// 
			this.creaturePlayFieldAnts.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.creaturePlayFieldAnts.BackColor = System.Drawing.SystemColors.Control;
			this.creaturePlayFieldAnts.Creatures = null;
			this.creaturePlayFieldAnts.FieldColor = System.Drawing.Color.White;
			this.creaturePlayFieldAnts.Location = new System.Drawing.Point(8, 8);
			this.creaturePlayFieldAnts.Name = "creaturePlayFieldAnts";
			this.creaturePlayFieldAnts.Size = new System.Drawing.Size(392, 442);
			this.creaturePlayFieldAnts.Style = System.Drawing.Drawing2D.InterpolationMode.Bilinear;
			this.creaturePlayFieldAnts.TabIndex = 14;
			this.creaturePlayFieldAnts.TabStop = false;
			// 
			// groupBoxDisplay
			// 
			this.groupBoxDisplay.Anchor = (System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right);
			this.groupBoxDisplay.Controls.AddRange(new System.Windows.Forms.Control[] {
																						  this.radioButtonBicubic,
																						  this.radioButtonBilinear,
																						  this.radioButtonBlocks,
																						  this.buttonClear});
			this.groupBoxDisplay.Location = new System.Drawing.Point(408, 360);
			this.groupBoxDisplay.Name = "groupBoxDisplay";
			this.groupBoxDisplay.Size = new System.Drawing.Size(216, 96);
			this.groupBoxDisplay.TabIndex = 15;
			this.groupBoxDisplay.TabStop = false;
			this.groupBoxDisplay.Text = "Display";
			// 
			// radioButtonBicubic
			// 
			this.radioButtonBicubic.Location = new System.Drawing.Point(8, 64);
			this.radioButtonBicubic.Name = "radioButtonBicubic";
			this.radioButtonBicubic.Size = new System.Drawing.Size(88, 24);
			this.radioButtonBicubic.TabIndex = 2;
			this.radioButtonBicubic.Text = "Bicubic";
			this.radioButtonBicubic.CheckedChanged += new System.EventHandler(this.radioButtonBicubic_CheckChanged);
			// 
			// radioButtonBilinear
			// 
			this.radioButtonBilinear.Location = new System.Drawing.Point(8, 40);
			this.radioButtonBilinear.Name = "radioButtonBilinear";
			this.radioButtonBilinear.Size = new System.Drawing.Size(88, 24);
			this.radioButtonBilinear.TabIndex = 1;
			this.radioButtonBilinear.Text = "Bilinear";
			this.radioButtonBilinear.CheckedChanged += new System.EventHandler(this.radioButtonBilinear_CheckChanged);
			// 
			// radioButtonBlocks
			// 
			this.radioButtonBlocks.Location = new System.Drawing.Point(8, 16);
			this.radioButtonBlocks.Name = "radioButtonBlocks";
			this.radioButtonBlocks.Size = new System.Drawing.Size(88, 24);
			this.radioButtonBlocks.TabIndex = 0;
			this.radioButtonBlocks.Text = "Blocks";
			this.radioButtonBlocks.CheckedChanged += new System.EventHandler(this.radioButtonBlocks_CheckChanged);
			// 
			// FormLangtonsAnt
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(632, 459);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.creaturePlayFieldAnts,
																		  this.groupBoxPopulation,
																		  this.groupBoxSelectedAnt,
																		  this.groupBoxNewAnt,
																		  this.groupBoxDisplay});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.Menu = this.mainMenu;
			this.MinimizeBox = false;
			this.Name = "FormLangtonsAnt";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Langton\'s Ant";
			this.groupBoxSelectedAnt.ResumeLayout(false);
			this.groupBoxNewAnt.ResumeLayout(false);
			this.groupBoxNewAntColor.ResumeLayout(false);
			this.groupBoxDirection.ResumeLayout(false);
			this.groupBoxPopulation.ResumeLayout(false);
			this.groupBoxDisplay.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new FormLangtonsAnt());
		}

		
		
		private void redrawPlayField()
		{
			creaturePlayFieldAnts.Invalidate();
			creaturePlayFieldAnts.Update();
		}

		private void buttonPopulationWalk_Click(object sender, System.EventArgs e)
		{
			if(ants.Count > 0)
			{
				if(running)
				{
					stopProcessThread();
				}
				else
				{
					startProcessThread();
				}
				
				updateAntControls();
				updatePopulationControls();
				updateMenuItems();
			}
			else
			{
				MessageBox.Show("There are no ants!",this.Text,MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void updateMenuItems()
		{
			if(running)
			{
				menuItemFile.Enabled = false;
				menuItemOptions.Enabled = false;
				menuItemHelp.Enabled = false;
			}
			else
			{
				menuItemFile.Enabled = true;
				menuItemOptions.Enabled = true;
				menuItemHelp.Enabled = true;
			}
		}

		private void buttonNewAnt_Click(object sender, System.EventArgs e)
		{
			int dx = 0, dy = 0;
			if(radioButtonNewAntLeft.Checked)
			{
				dx = -1;
			}
			if(radioButtonNewAntRight.Checked)
			{
				dx = 1;
			}
			if(radioButtonNewAntUp.Checked)
			{
				dy = -1;
			}
			if(radioButtonNewAntDown.Checked)
			{
				dy = 1;
			}

			LangtonsAnt ant = null;
			if(ants.Count > 0)
			{
				ant = ants[selectedAntIndex] as LangtonsAnt;
			
				if(ant != null)
				{
					ant.Color = AntColor;
				}

			}

			ant = new LangtonsAnt(creaturePlayFieldAnts.Width, creaturePlayFieldAnts.Height,  SelectedAntColor, dx, dy, labelNewAntColor1.BackColor, labelNewAntColor2.BackColor);
			ant.Running = true;
			ants.Add(ant);

			selectedAntIndex = ants.Count-1;
			updateAntControls();
			updatePopulationControls();
			if(!running)
			{
				redrawPlayField();
			}
		}

		private void processAnt(int index)
		{
			LangtonsAnt ant = ants[index] as LangtonsAnt;
			if(ant != null)
			{
				if(ant.Running)
				{					
					ant.Forward();

					int x = ant.X;
					int y = ant.Y;

					Color oldSquareColor = creaturePlayFieldAnts.Read(x, y);
					Color newSquareColor = ant.ProcessRules(oldSquareColor);
										
					creaturePlayFieldAnts.PersistentPlot(x, y, newSquareColor);
				}
			}
		}

		private void processAnts()
		{
			for(int index = 0; index < ants.Count; index++)
			{
				processAnt(index);
			}
			steps++;
		}

		private void run()
		{
			while(running)
			{
				processAnts();
				redrawPlayField();
				showStatistics();
			}

		}

		private void showStatistics()
		{
			labelRuns.Text = "Steps: " + steps.ToString();
		}

		private void clearField()
		{
			creaturePlayFieldAnts.Clear();
			steps = 0;
		}

		private void startProcessThread()
		{
			processAntsThread = new Thread(new ThreadStart(run));
			running = true;
			processAntsThread.Priority = antPriority;
			processAntsThread.Start();

		}
		private void stopProcessThread()
		{
			running = false;

			if(processAntsThread != null)
			{
				processAntsThread.Join();
			}
			processAntsThread = null;
		}

		private void buttonClear_Click(object sender, System.EventArgs e)
		{
			bool shouldContinue = running;
			stopProcessThread();
						
			clearField();
			redrawPlayField();
			showStatistics();
			if(shouldContinue)
			{
				startProcessThread();
			}
			updateAntControls();
			updatePopulationControls();
			updateMenuItems();
		}

		private void buttonOneStep_Click(object sender, System.EventArgs e)
		{
			if(!running)
			{
				if(ants.Count > 0)
				{
					processAnts();
					redrawPlayField();
					showStatistics();
				}
				else
				{
					MessageBox.Show("There are no ants!",this.Text,MessageBoxButtons.OK, MessageBoxIcon.Error);
				}
			}
		}

		private void buttonPreviousAnt_Click(object sender, System.EventArgs e)
		{
			if(selectedAntIndex > 0)
			{
				selectedAntIndex--;
			}
			else
			{
				selectedAntIndex = ants.Count - 1;
			}

			redrawPlayField();
			updateAntControls();
		}

		private void buttonNextAnt_Click(object sender, System.EventArgs e)
		{
			LangtonsAnt ant = ants[selectedAntIndex] as LangtonsAnt;
			if(ant != null)
			{
				ant.Color = Color.Blue;
			}
			if(selectedAntIndex < ants.Count - 1)
			{
				selectedAntIndex++;
			}
			else
			{
				selectedAntIndex = 0;
			}
			
			ant = ants[selectedAntIndex] as LangtonsAnt;
			if(ant != null)
			{
				ant.Color = SelectedAntColor;
			}
			redrawPlayField();
			updateAntControls();
		}

		private void updatePopulationControls()
		{
			if(running)
			{
				buttonPopulationWalk.Text = "Pause";
				buttonOneStep.Enabled = false;
			}
			else
			{
				buttonPopulationWalk.Text = "Walk";
				buttonOneStep.Enabled = true;
			}
		}
		private void updateAntControls()
		{
			if(ants.Count > 0 && selectedAntIndex>=0 && selectedAntIndex < ants.Count && !running)
			{
				LangtonsAnt ant = ants[selectedAntIndex] as LangtonsAnt;
				if(ant != null)
				{
					groupBoxSelectedAnt.Enabled = true;
					if(ant.Running)
					{
						buttonPauseAnt.Text = "Pause";
					}
					else
					{
						buttonPauseAnt.Text = "Walk";
					}
				}

			}
			else
			{
				groupBoxSelectedAnt.Enabled = false;
			}
		}
		private void buttonRemoveAnt_Click(object sender, System.EventArgs e)
		{
			try
			{
				ants.RemoveAt(selectedAntIndex);
				if(selectedAntIndex == ants.Count)
					selectedAntIndex = 0;

				redrawPlayField();
				showStatistics();
				updateAntControls();
			}
			catch(IndexOutOfRangeException iore)
			{
				MessageBox.Show(iore.Message + "\nThere are no ants!",this.Text,MessageBoxButtons.OK, MessageBoxIcon.Error);
			}
		}

		private void buttonPauseAnt_Click(object sender, System.EventArgs e)
		{
			LangtonsAnt ant = ants[selectedAntIndex] as LangtonsAnt;
			if(ant != null)
			{
				ant.Running = !ant.Running;
				buttonPauseAnt.Text = ant.Running?"Pause":"Walk";
			}
		}

		private void buttonMoveAntUp_Click(object sender, System.EventArgs e)
		{
			LangtonsAnt ant = ants[selectedAntIndex] as LangtonsAnt;
			if(ant != null)
			{
				ant.Y--;
				creaturePlayFieldAnts.AdjustViewTo(ant.X, ant.Y);
				redrawPlayField();
			}
		}

		private void buttonMoveAntDown_Click(object sender, System.EventArgs e)
		{
			LangtonsAnt ant = ants[selectedAntIndex] as LangtonsAnt;
			if(ant != null)
			{
				ant.Y++;
				creaturePlayFieldAnts.AdjustViewTo(ant.X, ant.Y);
				redrawPlayField();
			}
		}

		private void buttonMoveAntLeft_Click(object sender, System.EventArgs e)
		{
			LangtonsAnt ant = ants[selectedAntIndex] as LangtonsAnt;
			if(ant != null)
			{
				ant.X--;
				creaturePlayFieldAnts.AdjustViewTo(ant.X, ant.Y);
				redrawPlayField();
			}
		}

		private void buttonMoveAntRight_Click(object sender, System.EventArgs e)
		{
			LangtonsAnt ant = ants[selectedAntIndex] as LangtonsAnt;
			if(ant != null)
			{
				ant.X++;
				creaturePlayFieldAnts.AdjustViewTo(ant.X, ant.Y);
				redrawPlayField();
			}
		}

		
		private void labelNewAntColor1_Click(object sender, System.EventArgs e)
		{
			if(colorDialog.ShowDialog() == DialogResult.OK)
			{
				labelNewAntColor1.BackColor = colorDialog.Color;
			}
		}

		private void attachToolTips()
		{
			toolTip.SetToolTip(labelNewAntColor1, "Click to change");
			toolTip.SetToolTip(labelNewAntColor2, "Click to change");
			toolTip.SetToolTip(buttonMoveAntUp, "Move ant up");
			toolTip.SetToolTip(buttonMoveAntDown, "Move ant down");
			toolTip.SetToolTip(buttonMoveAntLeft, "Move ant left");
			toolTip.SetToolTip(buttonMoveAntRight, "Move ant right");
			toolTip.SetToolTip(buttonPopulationKill, "Remove all ants");
			toolTip.SetToolTip(buttonPreviousAnt, "Select previous ant");
			toolTip.SetToolTip(buttonNextAnt, "Select next ant");
			toolTip.SetToolTip(buttonClear, "Clear field (keep ants)");
			toolTip.SetToolTip(buttonPopulationKill, "Clear field (remove ants)");
		}

		private void buttonPopulationKill_Click(object sender, System.EventArgs e)
		{
			stopProcessThread();
			ants.Clear();
			clearField();
			redrawPlayField();
			updateAntControls();
			updatePopulationControls();
			updateMenuItems();
			showStatistics();
		}

		private void menuItemSetBackgroundColor_Click(object sender, System.EventArgs e)
		{
			bool shouldContinue = false;
			if(colorDialog.ShowDialog() == DialogResult.OK)
			{
				if(running)
				{
					stopProcessThread();
					shouldContinue = true;
				}
				creaturePlayFieldAnts.FieldColor = colorDialog.Color;
				if(shouldContinue)
				{
					startProcessThread();
				}
			}
		}

		private void labelNewAntColor2_Click(object sender, System.EventArgs e)
		{
			if(colorDialog.ShowDialog() == DialogResult.OK)
			{
				labelNewAntColor2.BackColor = colorDialog.Color;
			}
		}

		private void menuItemExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		protected override void OnPaint(PaintEventArgs e)
		{
			base.OnPaint(e);
			if(!running)
			{
				redrawPlayField();
			}
		}

		private void menuItemAntPriority_Select(object sender, System.EventArgs e)
		{
            menuItemAntPriorityNormal.Checked = (antPriority == ThreadPriority.Normal);
			menuItemAntPriorityFast.Checked = (antPriority == ThreadPriority.AboveNormal);
			menuItemAntPriorityFastest.Checked = (antPriority == ThreadPriority.Highest);
			menuItemAntPrioritySlow.Checked = (antPriority == ThreadPriority.BelowNormal);
			menuItemAntPrioritySlowest.Checked = (antPriority == ThreadPriority.Lowest);
		}

		private void menuItemAntPrioritySlowest_Click(object sender, System.EventArgs e)
		{
			antPriority = ThreadPriority.Lowest;
			if(running)
                processAntsThread.Priority = antPriority;
		}

		private void menuItemAntPrioritySlow_Click(object sender, System.EventArgs e)
		{
			antPriority = ThreadPriority.BelowNormal;
			if(running)
				processAntsThread.Priority = antPriority;
		}

		private void menuItemAntPriorityNormal_Click(object sender, System.EventArgs e)
		{
			antPriority = ThreadPriority.Normal;
			if(running)
				processAntsThread.Priority = antPriority;
		}

		private void menuItemAntPriorityFast_Click(object sender, System.EventArgs e)
		{
			antPriority = ThreadPriority.AboveNormal;
			if(running)
				processAntsThread.Priority = antPriority;
		}

		private void menuItemAntPriorityFastest_Click(object sender, System.EventArgs e)
		{
			antPriority = ThreadPriority.Highest;
			if(running)
				processAntsThread.Priority = antPriority;
		}

		private void radioButtonBlocks_CheckChanged(object sender, System.EventArgs e)
		{
			if(radioButtonBlocks.Checked)
				creaturePlayFieldAnts.Style = InterpolationMode.NearestNeighbor;
		}

		private void radioButtonBilinear_CheckChanged(object sender, System.EventArgs e)
		{
			if(radioButtonBilinear.Checked)
				creaturePlayFieldAnts.Style = InterpolationMode.HighQualityBilinear;
		}

		private void radioButtonBicubic_CheckChanged(object sender, System.EventArgs e)
		{
			if(radioButtonBicubic.Checked)
				creaturePlayFieldAnts.Style = InterpolationMode.HighQualityBicubic;
		}

		private void menuItemAbout_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("Langton\'s Ants \nby\n Erno de Weerd\n2002","About",MessageBoxButtons.OK,MessageBoxIcon.Information,MessageBoxDefaultButton.Button1, MessageBoxOptions.RightAlign);
		}

		

		
		
		

		
		
		
		
		

		


		
		

		

		
	}
}
