VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsAnt"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

' ---------------------------------------------------------
'
' Class Ant (clsAnt.cls)
'
' Purpose:
'   Represents a Langton's Ant and its properties (X, Y and direction).
'
' ---------------------------------------------------------


'
' public Types
'


' Represents the direction of the ant.
Public Enum Direction
    North
    West
    South
    East
End Enum


'
' Private Variables
'


' The name (key) of the ant.
Private mstrName As String
' The current X & Y positions of the ant inside the grid.
Private mlngX As Long
Private mlngY As Long
' The current direction of the ant.
Private mdirDirection As Direction
' The current number of rounds the ant has been through.
Private mlngRounds As Long


'
' Public Properties
'


' Name Property (Read Only)
Public Property Get Name() As String
    Name = mstrName
End Property

' X Property (Read Only)
Public Property Get X() As Long
    X = mlngX
End Property

' Y Property (Read Only)
Public Property Get Y() As Long
    Y = mlngY
End Property

' Direction Property (Read Only)
Public Property Get Direction() As Direction
    Direction = mdirDirection
End Property

' Rounds Property (Read Only)
Public Property Get Rounds() As Long
    Rounds = mlngRounds
End Property


'
' Public Subs
'


'
' Procedure Initialize
'
' Purpose:
'   Initializes the ant with user-defined X and Y positions.
'
Public Sub Initialize(Name As String, Optional X As Long = 0, Optional Y As Long = 0, Optional Dir As Direction = North, Optional Rounds As Long = 0)
    If (Name <> "") Then mstrName = Name
    If (X >= 0) Then mlngX = X
    If (Y >= 0) Then mlngY = Y
    
    mdirDirection = Dir
    mlngRounds = Rounds
End Sub


'
' Procedure TurnLeft
'
' Purpose:
'   Makes the ant turn left.
'
Public Sub TurnLeft()
    mdirDirection = mdirDirection + 1
    
    If (mdirDirection > East) Then mdirDirection = North
End Sub


'
' Procedure TurnRight
'
' Purpose:
'   Makes the ant turn right.
'
Public Sub TurnRight()
    mdirDirection = mdirDirection - 1
    
    If (mdirDirection < North) Then mdirDirection = East
End Sub


'
' Procedure MoveForward
'
' Purpose:
'   Makes the ant turn Forward by one step.
'
Public Sub MoveForward()

    ' Move Forward according to the ant's direction.
    Select Case mdirDirection
        Case North
            mlngY = mlngY - 1
        Case West
            mlngX = mlngX - 1
        Case South
            mlngY = mlngY + 1
        Case East
            mlngX = mlngX + 1
    End Select
    
    mlngRounds = mlngRounds + 1
End Sub
